$(document).ready(function () {
    $("#generate > .spinner").hide();
    getNewData();
    $("#generate").on('click', function (e) {
        e.preventDefault();
        $("#generate > .spinner").show();
        getNewData();
    });

    function getNewData() {
        var request = $.ajax({
            url: "includes/chartprocess.php",
            method: "POST",
            data: $("#chartReports").serialize() + '&action=manageChart',
            success: function (response) {
                console.log(response);
                var data = JSON.parse(response);
                console.log(data);
                chartFunc(data);
                setTimeout(() => {
                    $("#generate > .spinner").hide();
                }, 1500);
            }
        });
    }
});
// chart option

// BEGIN LINE CHART ============================================


function chartFunc(data) {

    $("#myGraph").remove();
    $(".canvas-box").append('<canvas id="myGraph" class="canvas" width="500px" height="200px"></canvas>');

    var ctx = document.getElementById("myGraph").getContext("2d");
    
    window.chartColors = {
        red: 'rgb(255, 99, 132)',
        blue: 'rgb(54, 162, 235)',
        white: '#ffffff',
        black: 'rgba(0, 0, 0, 0.2)',
    };

    if (data.length === 0) {
        // No data is present
        dataTime = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
        dataCount = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        TotalCount = 0;
    } else {
        var dataTime = data.map(function (e) {
            return e[1].slice(0, 10);
        });

        var dataCount = data.map(function (e) {
            return e[2];
        });
        var Total = data.map(function (e) {
            return parseInt(e[2]);
        });

        var TotalCount = Total.reduce(function (acc, val) {
            return acc + val;
        }, 0)
    }

    var gradient = ctx.createLinearGradient(0, 0, 0, 240);
    gradient.addColorStop(0, 'rgba(0, 197, 220, 0.7)');
    gradient.addColorStop(1, "#f2feff");
    
    $('#total > h2').text(TotalCount);
    
    var config = {
        type: 'line',
        data: {
            labels: dataTime,
            datasets: [{
                label: "TotalCount",
                backgroundColor: gradient, // Put the gradient here as a fill color
                borderColor: '#0dc8de',

                pointBackgroundColor: window.chartColors.white,
                pointBorderColor: window.chartColors.white,
                pointHoverBackgroundColor: window.chartColors.red,
                pointHoverBorderColor: window.chartColors.black,
                data: dataCount,
                // fill: true,
            }]
        },
        options: {
            responsive: true,
            title: {
                display: true,
                text: 'Mails Sended by day'
            },
            tooltips: {
                mode: 'index',
                intersect: false,
            },
            scales: {
                xAxes: [{
                    display: true,
                    scaleLabel: {
                        display: true,
                    }
                }],
                yAxes: [{
                    display: true,
                    scaleLabel: {
                        display: true,
                    },
                }]
            }
        }
    };

    var myLine = new Chart(ctx, config);

};