$(function () {

    'use strict';

    // Validate from Before Submit
    $('#add_campaign_submit,#update_campaign_submit').on('click', function(e) {
        e.preventDefault();
        var btn = $(this);
        var form = $(this).closest('form');           

        form.validate({
            rules: {
                campaign_name: {
                    required: true,
                }
            },
            messages: {
                campaign_name: {
                    required: "Please specify campaign name",
                }
            }
        });

        if (!form.valid()) {
            return;
        }

        btn.addClass('kt-spinner kt-spinner--right kt-spinner--sm kt-spinner--light').attr('disabled', true);

        form.submit();
    });

    // Validate User Forms 
    $('#add_new_user').on('click', function(e) {
        e.preventDefault();
        var btn = $(this);
        var form = $(this).closest('form');           

        form.validate({
            rules: {
                user: {
                    required: true,
                    minlength: 5,
                    maxlength:  36
                },
                pass: {
                    required: true,
                    minlength: 8,
                    maxlength: 120
                },
                conf_pass: {
                    required: true,
                    minlength: 8,
                    maxlength: 120,
                    equalTo: "#inputPassword"
                },
                email: {
                    required: true,
                    email: true
                }
            },
            messages: {
                user: {
                    required: "Please enter a username",
                    minlength: "Your username must consist of at least 5 characters",
                    maxlength: "Username can not be more then 36 characters",
                },
                password: {
                    required: "Please provide a password",
                    minlength: "Your password must be at least 8 characters long",
                    maxlength: "password can not be more then 120 characters",
                },
                conf_pass: {
					required: "Please provide a password",
                    minlength: "Your password must be at least 8 characters long",
                    maxlength: "password can not be more then 120 characters",
					equalTo: "Please enter the same password as above"
				},
                email:{
                    required: "Please enter a email address",
                    email: "Please enter a valid email address"
                }
            }
        });

        if (!form.valid()) {
            return;
        }

        btn.addClass('kt-spinner kt-spinner--right kt-spinner--sm kt-spinner--light').attr('disabled', true);

        form.submit();
    });
    // Validate User Forms 
    $('#add_new_scenario').on('click', function(e) {
        e.preventDefault();
        var btn = $(this);
        var form = $(this).closest('form');  

        form.validate({
            rules: {
                scenario_name: {
                    required: false
                },
                scenario_campaign: {
                    minlength:1
                },
                scenario_text: {
                    required: false
                },
            },
            messages: {
                scenario_name: {
                    required: "Scenario Name can not be empty.",
                },
                scenario_campaign: {
                    minlength: "Please Choose Campaign for Scenario to complete"
                },
                scenario_text: {
					required: "Please enter a scenario spintax",
				}
            }
        });

        if (!form.valid()) {
            return;
        }

        btn.addClass('kt-spinner kt-spinner--right kt-spinner--sm kt-spinner--light').attr('disabled', true);

        form.submit();
    });

    // Validate Group Forms 
    $('#add_new_group,#edit_group_button').on('click', function(e) {
        e.preventDefault();
        var btn = $(this);
        var form = $(this).closest('form');           

        form.validate({
            rules: {
                group_name: {
                    required: true
                },
            },
            messages: {
                group_name: {
                    required: "Please enter a group name",
                }
            }
        });

        if (!form.valid()) {
            return;
        }

        btn.addClass('kt-spinner kt-spinner--right kt-spinner--sm kt-spinner--light').attr('disabled', true);

        form.submit();
    });
    
    //Edit Account 
    $('#edit_account_info').on('click', function(e) {
        e.preventDefault();
        var btn = $(this);
        var form = $(this).closest('form');           

        form.validate({
            rules: {
                username: {
                    required: true,
                    minlength: 5,
                    maxlength: 36
                },
                email: {
                    required: true,
                    email: true
                }
            },
            messages: {
                username: {
                    required: "Please specify your name",
                    minlength: "Username can not be less then 5 characters",
                    maxlength: "Username can not be more then 36 characters",
                },
                email: {
                    required: "We need your email address to contact you",
                    email: "Your email address must be in the format of name@domain.com"
                }
            }
        });

        if (!form.valid()) {
            return;
        }

        btn.addClass('kt-spinner kt-spinner--right kt-spinner--sm kt-spinner--light').attr('disabled', true);

        form.submit();
    });
});