<?php

class Campaigns {

    private $db;
    private $session;

    public function __construct($db,$session) {
        $this->db = $db;
        $this->session = $session;
    }

    function fetchCampaigns() {
        $status = 0;
        $deleted = 0;
        $getAll = $this->db->prepare("SELECT * FROM campaign WHERE campaign_Status = ? AND campaign_Deleted = ?");
        $getAll->execute(array($status, $deleted));
        $all = $getAll->fetchAll();
        return $all;
    }

    public function returnCampaignInfo($id) {
        $sql = $this->db->prepare("SELECT * FROM `campaign` WHERE campaign_ID = ?");
        $sql->execute(array($id));
        return $campaigninfo = $sql->fetch();
    }

    public function RegisterNewCampaign($username) {

        $accountid = $this->session->id;

        //chekcif usernamealready exist
        $count = $this->db->prepare("SELECT COUNT('campaign_ID') FROM campaign WHERE campaign_Name = ? AND campaign_Creator = ?");

		$count->execute(array($username,$accountid));
        $check = $count->fetchColumn();
        
        if ($check > 0) {
            $field = "add_username";
            Form::setError($field, "You already have Campaign with this name");
        }

        /* Errors exist, have user correct them */
        if (Form::$num_errors > 0) {
            return false;  //Errors with form
        } else {
            // Insert Campaign In Database
            $stmt = $this->db->prepare("INSERT INTO
            campaign(campaign_Name, campaign_Date, campaign_Creator)
            VALUES(:zname, now(), :zcreator)");

            $stmt->execute(array(
            'zname' => $username,
            'zcreator' => $accountid
            ));
            return true;
        }

    }

    public function UpdateCampaign($username, $campaignid) {
        
        $accountid = $this->session->id;

        // chekc if campaign exist 
        $statement = $this->db->prepare("SELECT campaign_ID FROM campaign WHERE campaign_ID = ?");
		$statement->execute(array($campaignid));
        $count = $statement->rowCount();
        
        if ($count < 0) {
            $field = "general";
            Form::setError($field, "This Campaign did not exist, Try Again Pls!!");
        }
        
        //chekc if username already exist
        $count = $this->db->prepare("SELECT COUNT('campaign_ID') FROM campaign WHERE campaign_Name = ? AND campaign_Creator = ? AND campaign_ID != ?");

		$count->execute(array($username, $accountid, $campaignid));
        $check = $count->fetchColumn();
        
        if ($check > 0) {
            $field = "username";
            Form::setError($field, "This Campaign Name already choosed for this campaign try new one to not conflit");
        }

        /* Errors exist, have user correct them */
        if (Form::$num_errors > 0) {
            return false;  //Errors with form
        } else {
            // Insert Campaign In Database
            $stmt = $this->db->prepare("UPDATE campaign SET campaign_Name = ? WHERE campaign_ID = ?");

            $stmt->execute(array($username, $campaignid));
            return true;
        }

    }

    public function checkforemptyCampaign($username,$fieldName) {
        // $campaignfunctions->RegisterNewCampaign($name, $desc, $camp);
        if(empty($username)) {
            $field = $fieldName;
            Form::setError($field, "Campaign Name can not be empty");
        } 
        /* Errors exist, have user correct them */
        if (Form::$num_errors > 0) {
            return false;  //Errors with form
        } else {
            return true;
        }
    }

}