<?php

include_once 'controller.php';

if (!$session->isAdmin()) {
    header("Location: " . $configs->homePage());
    exit;
}

$form_submission = (isset($_POST['form_submission'])) ? $_POST['form_submission'] : $_GET['form_submission'];
switch ($form_submission) {
    case "campaign_registration" :
        RegisterCampaign($db, $campaigns, $session);
        break;
    case "edit_campaign" :
        EditCampaign($db, $campaigns);
        break;
    case "filter_campaign" :
        FilterCampaign($campaigns);
        break;
    case "manage_campaign" :
        if (isset($_POST['button']) && ($_POST['button'] == "Completed")) {
            CompletedCampaign($db, $functions, $session);
        } else
        if (isset($_POST['button']) && ($_POST['button'] == "Opened")) {
            OpenedCampaign($db, $functions, $session);
        } else
        if (isset($_POST['button']) && ($_POST['button'] == "Delete")) {
            deleteCampaign($db, $functions, $session);
        }
        break;
    default :
        header("Location: ../campaigns.php");
    
}

/**
 * ********************************************************************************************************
 * deleteInactive - All inactive users are deleted from the database, not including administrators. 
 * Inactivity is defined by the number of days specified that have gone by that the user has not logged in.
 * ********************************************************************************************************
 */
function RegisterCampaign($db, $campaigns, $session) {
    
    // Get Variables From The Form
    $username = $_POST['campaign_name'];
    $fieldName = "add_username";

    $campaigns->checkforemptyCampaign($username,$fieldName);

    /* Errors exist, have user correct them */
    if (Form::$num_errors > 0) {
        $_SESSION['value_array'] = $_POST;
        $_SESSION['error_array'] = Form::getErrorArray();
        header("Location: ../campaigns.php");
        return false;  //Errors with form
    } else {
        $campaignss = $campaigns->RegisterNewCampaign($username);

        if ($campaignss) {
            header("Location: ../campaigns.php");
        }
        else {
            $_SESSION['value_array'] = $_POST;
            $_SESSION['error_array'] = Form::getErrorArray();
            header("Location: ../campaigns.php");
        }
    }
    
}

function EditCampaign($db, $campaigns) {
    
    // Get Variables From The Form
    $name = $_POST['campaign_name'];
    $campaignid = $_POST['campaign_to_edit'];
    $fieldName = "username";

    $campaigns->checkforemptyCampaign($name,$fieldName);

    /* Errors exist, have user correct them */
    if (Form::$num_errors > 0) {
        $_SESSION['value_array'] = $_POST;
        $_SESSION['error_array'] = Form::getErrorArray();
        header("Location: ../campaigns.php");
        return false;  //Errors with form
    } else {
        $campaigno = $campaigns->UpdateCampaign($name, $campaignid);

        if ($campaigno) {
            header("Location: ../campaigns.php");
        }
        else {
            $_SESSION['value_array'] = $_POST;
            $_SESSION['error_array'] = Form::getErrorArray();
            header("Location: ../campaigns.php");
        }
    }

}

function deleteCampaign($db, $functions, $session) {
    $id = $session->id;

    /* Username error checking */
    $deleted_campaigns = $_POST['toEdit'];

    print($deleted_campaigns);

    $deleted_campaigns = implode(',', $deleted_campaigns );

    /* Ban user from member system */
    $sql = $db->prepare("UPDATE campaign SET campaign_Deleted = ? WHERE campaign_ID IN ($deleted_campaigns) AND campaign_Creator = ?");

    if($sql->execute(array(1,$id))) {
        header("Location: ../campaigns.php");
    } else {
        echo "problem";
    };
    
}
function CompletedCampaign($db, $functions, $session) {

    $id = $session->id;

    /* Username error checking */
    $deleted_campaigns = $_POST['toEdit'];


    $deleted_campaigns = implode(',', $deleted_campaigns );

    /* Ban user from member system */
    $sql = $db->prepare("UPDATE campaign SET campaign_Completed = ? WHERE campaign_ID IN ($deleted_campaigns) AND campaign_Creator = ?");

    if($sql->execute(array(1,$id))) {
        header("Location: ../campaigns.php");
    } else {
        echo "problem";
    };
    
}
function OpenedCampaign($db, $functions, $session) {

    $id = $session->id;

    /* Username error checking */
    $deleted_campaigns = $_POST['toEdit'];


    $deleted_campaigns = implode(',', $deleted_campaigns );

    /* Ban user from member system */
    $sql = $db->prepare("UPDATE campaign SET campaign_Completed = ? WHERE campaign_ID IN ($deleted_campaigns) AND campaign_Creator = ?");

    if($sql->execute(array(0,$id))) {
        header("Location: ../campaigns.php");
    } else {
        echo "problem";
    };
    
}
