"use strict";
// Class definition

var KTAppUserListDatatable = function() {

	// variables
	var datatable;

	// init
	var init = function() {
		datatable = $('#kt_apps_user_list_datatable').KTDatatable({
			// datasource definition
			data: {
				type: 'remote',
				source: {
					read: {
						url: 'includes/jsonData.php',
					},
				},
				pageSize: 10, // display 20 records per page
				serverPaging: true,
				serverFiltering: true,
				serverSorting: true,
			},

			// layout definition
			layout: {
				theme: 'default',
                class: '',
                height: 500,
				scroll: true, // enable/disable datatable scroll both horizontal and vertical when needed.
				footer: false, // display/hide footer
			},
			// column sorting
			sortable: true,

			pagination: true,

			search: {
				input: $('#generalSearch')
			},

			// columns definition
			columns: [
			{
				field: "campaign_ID",
				title: "#",
				sortable: false,
				width: 10,
				selector: {
					class: 'kt-checkbox--solid'
				},
				textAlign: 'left',
			},
            {
				field: "EdgCampaign",
				title: "Campaign Name",
				sortable: false,
				textAlign: 'left',
				width: 180,
				// callback function support for column rendering
				template: function(data, i) { 
					var output = '';
					if (data.creatorImg) {
						output = '<div class="kt-user-card-v2">\
								<div class="kt-user-card-v2__pic">\
									<img src="' + data.creatorImg + '" alt="photo">\
								</div>\
								<div class="kt-user-card-v2__details">\
									<a href="#" class="kt-user-card-v2__name">' + data.campaign_Name + '</a>\
									<span class="kt-user-card-v2__desc"> test </span>\
								</div>\
							</div>';
					} else {
						var stateNo = KTUtil.getRandomInt(0, 6);
						var states = [
							'success',
							'brand',
							'danger',
							'success',
							'warning',
							'primary',
							'info'
						];
						var state = states[stateNo];
						const CompletData = data.campaign_Completed == 1 ? "completed" : "open";
						const typeComplete = data.campaign_Completed == 1 ? "kt-badge--success" : "kt-badge--primary";
						output = '<div class="kt-user-card-v2">\
								<div class="kt-user-card-v2__pic">\
									<div class="kt-badge kt-badge--xl kt-badge--' + state + '">' + data.campaign_Name.substring(0, 1) + '</div>\
								</div>\
								<div class="kt-user-card-v2__details">\
									<a href="#" class="kt-user-card-v2__name">' + data.campaign_Name + '</a>\
									<span id="typeCampaignByID" data-type='+ data.campaign_Completed +' class="kt-badge kt-badge--inline ' + typeComplete +' ">' + CompletData + '</span>\
								</div>\
							</div>';
					}
					return output;
				}
			}, {
				field: 'NumberScenarios',
				title: 'Scenarios',
				width: 60,
				textAlign: 'left',
				sortable: false,
				template: function(row) {
					return `<span class="btn btn-bold btn-sm btn-font-sm btn-label-warning"> ${row[0].NumberScenarios} </span>`;
				},
			}, {
				field: 'NumberMails',
				title: 'Messages',
				sortable: false,
				width: 100,
				template: function(row) {
					return `<span class="btn btn-bold btn-sm btn-font-sm btn-label-brand"> ${row[0].NumberMails} </span>`;
				},
			},{
				field: 'NumberSendedMails',
				title: 'Sended Messages',
				width: 100,
				textAlign: 'left',
				sortable: false,
				template: function(row) {
					return `<span class="btn btn-bold btn-sm btn-font-sm btn-label-success"> ${row[0].NumberSendedMails} </span>`;
				},
			},{
				field: 'NumberRestMails',
				title: 'Waiting Messages',
				width: 100,
				textAlign: 'left',
				sortable: false,
				template: function(row) {
					return `<span class="btn btn-bold btn-sm btn-font-sm btn-label-danger"> ${row[0].NumberRestMails} </span>`;
				},
			},
			{
				field:'percentage',
				title: 'percentage',
				width: 240,
				textAlign: 'left',
				sortable: false,
				template: function(data) {
					let $colorType = 'bg-brand';
					if (data[0].percentage < 30) {
						$colorType = 'bg-danger';
					} else if (data[0].percentage >= 30 && data[0].percentage < 60) {
					$colorType = 'bg-warning'; 
					} else if (data[0].percentage >= 60 && data[0].percentage < 100) {
					$colorType = 'bg-brand';
					} else if (data[0].percentage = 100) { 
					$colorType = 'bg-success'; 
					}
					return  `
							<div class="kt-widget31__progress">
								<a href="#" class="kt-widget31__stats">
									<span>${data[0].percentage}%</span>
									<span>completed</span>						    							 
								</a>
								<div class="progress progress-sm">
									<div class="progress-bar ${$colorType}" role="progressbar" style="width: ${data[0].percentage}%" aria-valuenow="${data.percentage}" aria-valuemin="0" aria-valuemax="100"></div>
								</div>
							</div>
					`
				}
			},
			{
				field:'actions',
				title: 'actions',
				sortable: false,
				textAlign: 'left',
				width: 90,
				template: function(data) {
					return  `
						<form class='form-horizontal' method='POST' role='form' action='includes/campaignproces.php'>
							<div class='actions-btns'>
								<a href='#' data-logid="${data.campaign_ID}" data-target='#editCampaign' data-toggle='modal' title='Edit' class='open_modal btn btn-primary btn-sm'>
									<i class='flaticon-edit'></i>edit
								</a>
                            </div>
                        </form>
					`
				}
			}]
		});
	}

	// search
	var search = function() {
		
	} 
	

	// selection
	var selection = function() {
		// init form controls
		$('#kt_form_status, #kt_form_type').selectpicker();

		// event handler on check and uncheck on records
		datatable.on('kt-datatable--on-check kt-datatable--on-uncheck kt-datatable--on-layout-updated',	function(e) {
			var checkedNodes = datatable.rows('.kt-datatable__row--active').nodes(); // get selected records
			var count = checkedNodes.length; // selected records count

			$('#kt_subheader_group_selected_rows').html(count);
			
			// fetch selected IDs
			var idss = datatable.rows('.kt-datatable__row--active').nodes().find('#typeCampaignByID').map(function(i, chk) { 
				return $(chk).data('type');
			});

			// Check if All Array values is equal -- open option -- return true or false
			function isOpen(currentValue) {
				return currentValue == 0;
			}

			// Check if All Array values is equal -- Completd option -- return true or false
			function isCompleted(currentValue) {
				return currentValue == 1;
			}

			var Lists = [];

			for (var i = 0; i < idss.length; i++) { 
				Lists.push(idss[i]);
			}
			
			// SHow and Hide Btn
			if(Lists.every(isOpen) && Lists.length > 0) {
				$('#kt_subheader_group_actions_completed_all').removeClass('kt-hidden');
			} else if(Lists.every(isCompleted) && Lists.length > 0) {
				$('#kt_subheader_group_actions_Opened_all').removeClass('kt-hidden');
			} else {
				$('#kt_subheader_group_actions_Opened_all').addClass('kt-hidden');
				$('#kt_subheader_group_actions_completed_all').addClass('kt-hidden');
			}
			

			if (count > 0) {
				$('#kt_subheader_search').addClass('kt-hidden');
				$('#kt_subheader_group_actions').removeClass('kt-hidden');
			} else {
				$('#kt_subheader_search').removeClass('kt-hidden');
				$('#kt_subheader_group_actions').addClass('kt-hidden');
			}
		});
	}

	function getChecked() {
		$('#manageCampaignForm').find('#kt_apps_user_fetch_records_selected').empty();
		// show loading dialog
		var loading = new KTDialog({'type': 'loader', 'placement': 'top center', 'message': 'Loading ...'});
		loading.show();

		setTimeout(function() {
			loading.hide();
		}, 1000);
		
		// fetch selected IDs
		var ids = datatable.rows('.kt-datatable__row--active').nodes().find('.kt-checkbox--single > [type="checkbox"]').map(function(i, chk) { 
			return $(chk).val();
		});

		// populate selected IDs
		var c = document.createDocumentFragment();
			
		for (var i = 0; i < ids.length; i++) {
			var option = document.createElement('option');
			option.setAttribute('value', ids[i]);
			option.setAttribute('selected', 'selected');
			option.innerHTML = 'Selected record ID: ' + ids[i];
			c.appendChild(option);
		}
		
		$('#manageCampaignForm').find('#kt_apps_user_fetch_records_selected').append(c);
	}

	// Mark As completed
	var selectedCompleted = function() {
		$('#kt_subheader_group_actions_completed_all').on('click', function() {

			// fetch selected IDs
			var ids = datatable.rows('.kt-datatable__row--active').nodes().find('.kt-checkbox--single > [type="checkbox"]').map(function(i, chk) { 
				return $(chk).val();
			});

			getChecked();

			$('#ManageCamapignBtn').val('Completed');

			if (ids.length > 0) {
				if(window.confirm('Really want to delete')) {
					$('#ManageCamapignBtn').click();
				} else {
					console.log("cancel")
				}
			}
		});		
	}
	// Mark As Opened
	var selectedOpened = function() {
		$('#kt_subheader_group_actions_Opened_all').on('click', function() {

			// fetch selected IDs
			var ids = datatable.rows('.kt-datatable__row--active').nodes().find('.kt-checkbox--single > [type="checkbox"]').map(function(i, chk) { 
				return $(chk).val();
			});

			getChecked();

			$('#ManageCamapignBtn').val('Opened');

			if (ids.length > 0) {
				if(window.confirm('Really want to delete')) {
					$('#ManageCamapignBtn').click();
				} else {
					console.log("cancel")
				}
			}
		});		
	}
	// selected records delete
	var selectedDelete = function() {
		$('#kt_subheader_group_actions_delete_all').on('click', function(e) {
			e.preventDefault(); 
			// fetch selected IDs
			var ids = datatable.rows('.kt-datatable__row--active').nodes().find('.kt-checkbox--single > [type="checkbox"]').map(function(i, chk) { 
				return $(chk).val();
			});

			getChecked();

			$('#ManageCamapignBtn').val('Delete');

			if (ids.length > 0) {
				if(window.confirm('Really want to delete')) {
					$('#ManageCamapignBtn').click();
				} else {
					console.log("cancel")
				}
			}
		});		
	}

	
	return {
		// public functions
		init: function() {
			init();
			search();
			selection();
			selectedDelete();
			selectedCompleted();
			selectedOpened();
		},
	};
}();

// On document ready
KTUtil.ready(function() {
	KTAppUserListDatatable.init();
	new PerfectScrollbar('.kt-datatable__table');
});
