<?php

class Mails {

    private $db;
    

    public function __construct($db,$session,$configs) {
        $this->db = $db;
        $this->session = $session;
        $this->configs = $configs;
    }

    /* *******************************************************************
     * Fetch Mails
     * *******************************************************************
    */
    function fetchmail() {
        $query = "SELECT * FROM mails WHERE mail_manage = :manage AND mail_state = :mstate LIMIT 1";
        $stmt = $this->db->prepare($query);
        $stmt->execute(array(':manage' => 1, ':mstate' => 0));
        $dbarray = $stmt->fetch();
        /* Error occurred, return given name by default */
        // $result = count($dbarray);

        date_default_timezone_set('Europe/London');
        $date = date('Y-m-d H:i:s');

        if (!$dbarray) {
            $field = "general";
            Form::setError($field, "There is no Mails Available for moment");
            $_SESSION['value_array'] = $_POST;
            $_SESSION['error_array'] = Form::getErrorArray();
            // header("Location: workspace.php");
            return NULL;
        } else {
            // Set mail as open for now
            $openid = $dbarray['mail_id'];
            $query = "UPDATE mails SET mail_manage = :mailmanage, mail_time_open = :dateopen WHERE mail_id = :mailid";
            $stmt = $this->db->prepare($query);
            $stmt->execute(array(':mailmanage' => 1, ':dateopen' => $date, ':mailid' => $openid));
            /* Return result array */
            return $dbarray;
        }
    }

    /* *******************************************************************
     * get Mail Details
     * *******************************************************************
    */
    function getmailInfo() {
        $sessionid = $this->session->id;
        
        //get user id
        $sql = "SELECT mail_used FROM users WHERE id = ?";
        $result = $this->db->prepare($sql);
        $result->execute(array($sessionid));
        $row = $result->fetch(); 
        $used_mail = $row['mail_used'];

        $sql2 = "SELECT * FROM used_mails WHERE mail_id = ?"; 
        $result2 = $this->db->prepare($sql2);
        $result2->execute(array($used_mail));
        $row2 = $result2->fetch(); 

        return $row2;
    }
    /* *******************************************************************
     * Add mail
     * *******************************************************************
    */
    function addmail($email,$pass) {
        $query = "INSERT INTO used_mails(mail_email, mail_pass) VALUES (:mailemail, :mailpass)";
        $stmt = $this->db->prepare($query);
        $stmt->execute(array(':mailemail' => $email,':mailpass' => $pass)); 
    }

    /* *******************************************************************
     * Check if they choose Campaign for mails
     * *******************************************************************
    */
    public function checkforemptyCamp($campaign, $file) {
        // $scenariofunctions->RegisterNewScenario($name, $desc, $camp);
        if(empty($campaign) || $campaign <= 0) {
            $field = "mails";
            Form::setError($field, "Try Chooe campaign");
        } 
        /* Errors exist, have user correct them */
        if (Form::$num_errors > 0) {
            return false;  //Errors with form
        } else {
            return true;
        } 
    }

    public function checkforemptyMails($campaign, $file) {
        if(empty($file)) {
            $field = "mails";
            Form::setError($field, "file can not be empty");
        }  
        /* Errors exist, have user correct them */
        if (Form::$num_errors > 0) {
            return false;  //Errors with form
        } else {
            return true;
        }
    }

    /**
    * *********************************************
    * Send mails.
    * *********************************************
    */
    public function SendMails($openid,$to_email,$subject,$body,$title,$typesend) { 
        $mailres = $this->getmailInfo();
        
        $from_email = $mailres['mail_email'];
        $from_pass = $mailres['mail_pass'];
        $from_email_id = $mailres['mail_id'];
        $mailuser = $this->session->id;
        $date = date('Y-m-d H:i:s');

        if(empty($subject)) {
            $subject = "message From Dxseo Platforme";
        }

        if($typesend == "usesendgrid") {
            //SendGrid
            $mailergrid = new Mailergrid($this->db, $this->configs);
            $res = $mailergrid->sendMails($title, $to_email, $subject, $body, $from_email);
        } else if($typesend == "usegmail") {
            // Gmail
            $mailergmail = new Mailergmail($this->db, $this->configs);
            $res = $mailergmail->sendMails($title, $to_email, $subject, $body, $from_email, $from_pass);
        }
        
        
        if ($res) {
            // Set mail as open for now
            $query = "UPDATE mails SET mail_manage = :mailmanage, mail_state = :mailstate, mail_user = :mailuser, mail_email_used = :mailused, mail_date_finished = now() WHERE mail_id = :mailid";
            $stmt = $this->db->prepare($query);
            if ($stmt->execute(array(
                ':mailmanage' => 0, 
                ':mailstate' => 1,
                ':mailuser' => $mailuser, 
                ':mailused' => $from_email_id, 
                ':mailid' => $openid)
                )) {
                // Succuss Message 
                $result = array('message' => 'success', 'text' => "email send successufely !!");
                echo json_encode($result);
            } 
        } else {
            $result = array('message' => 'error', 'text' => "There is something Wrong Pls try Again");
            echo json_encode($result);
        }
    }
}