<?php

class Numbers {

    private $db;
    private $session;

    public function __construct($db,$session) {
        $this->db = $db;
        $this->session = $session;
    }

    /* *******************************************************************
     * Total Campaigns
     * *******************************************************************
    */
    function totalCampaigns($state) {
        $cond = '';
        if($state == 'open') {
            $cond = 'AND campaign_Completed = 0';
        } else if ($state == 'completed') {
            $cond = 'AND campaign_Completed = 1';
        }
        $accountid = $this->session->id;
        $status = 0;
        $getAll = $this->db->prepare("SELECT campaign_ID FROM campaign WHERE campaign_Creator = ? AND campaign_Status = ? AND campaign_Deleted = ? $cond");
		$getAll->execute(array($accountid,$status, 0));
		$all = $getAll->rowCount();
		return $all;
    }

    /* *******************************************************************
     * Total Scenarios
     * *******************************************************************
    */
    function totalScenarios($state) {
        $cond = '';
        if($state == 'active') {
            $cond = 'scenario_Status = 0';
        } else if ($state == 'deactive') {
            $cond = 'scenario_Status = 1';
        }  
        $getAll = $this->db->prepare("SELECT scenario_ID FROM scenario WHERE $cond");
		$getAll->execute(array());
		$all = $getAll->rowCount();
		return $all;
    }

    /* *******************************************************************
     * Total Scenarios
     * *******************************************************************
    */
    function totalmailsopen() {
        date_default_timezone_set('Europe/London'); 
        $date = date('Y-m-d H:i:s', strtotime('-10 minutes'));

        $stmt = $this->db->prepare("SELECT mail_id FROM mails WHERE mail_manage = 1 AND mail_time_open < ?");
        $stmt->execute(array($date));

		$all =  $stmt->rowCount();
		return $all;
    }

    /* *******************************************************************
     * Total Users
     * *******************************************************************
    */
    function totalUsers() { 
        $getAll = $this->db->prepare("SELECT id FROM users");
		$getAll->execute(array());
		$all = $getAll->rowCount();
		return $all;
    }

    /* *******************************************************************
     * Total Accounts
     * *******************************************************************
    */
    function totalAccounts() { 
        $getAll = $this->db->prepare("SELECT mail_id FROM used_mails");
		$getAll->execute(array());
		$all = $getAll->rowCount();
		return $all;
    }

    /* *******************************************************************
     * Total mails
     * *******************************************************************
    */
    function totalMail($state) {
        $cond = '';
        if($state == 'sended') {
            $cond = 'mail_state = 1';
        } else if ($state == 'open') {
            $cond = 'mail_state = 0';
        }
        $getAll = $this->db->prepare("SELECT mail_id FROM mails WHERE $cond");
		$getAll->execute(array());
		$all = $getAll->rowCount();
		return $all;
    }


}