<?php

class Scenarios {

    private $db;
    private $session;

    public function __construct($db,$session) {
        $this->db = $db;
        $this->session = $session;
    }

    /* *******************************************************************
     * Fetch Scenarios
     * *******************************************************************
    */
    function fetchScenarios($filterid) {
        if(!empty($filterid) || $filterid != 0) {
            $cond = "AND scenario.scenario_campaign_ID = '$filterid'"; 
        } else {
            $cond = '';
        }
        
        $accountid = $this->session->id;
        $stmt2 = $this->db->prepare("SELECT 
            scenario.*,
            campaign.campaign_Name AS campaign_name,
            campaign.campaign_Status,
            campaign.campaign_Creator
        FROM
            scenario
        INNER JOIN 
            campaign
        ON
            campaign.campaign_ID = scenario.scenario_campaign_ID 
        WHERE campaign.campaign_Status != ? AND campaign.campaign_Creator = ? AND campaign.campaign_Deleted = ? $cond"); 
        
        $stmt2->execute(array(1,$accountid,0)); 
        $scenarios = $stmt2->fetchAll(); // Scenario Array
        return $scenarios;
    }
    
    public function RegisterNewScenario($username, $text, $campaign) {

        //chekcif username already exist
        $count = $this->db->prepare("SELECT COUNT('scenario_ID') FROM scenario WHERE scenario_Name = ? AND scenario_campaign_ID = ?");

		$count->execute(array($username,$campaign));
        $check = $count->fetchColumn();
        
        if ($check > 0) {
            $field = "add_sc_username";
            Form::setError($field, "This Scenario Name already choosed for this campaign try new one to not conflit");
        }

        /* Errors exist, have user correct them */
        if (Form::$num_errors > 0) {
            return false;  //Errors with form
        } else {
            // Insert Scenario In Database
            $stmt = $this->db->prepare("INSERT INTO
            scenario(scenario_Name, scenario_Text, scenario_campaign_ID, scenario_Date, scenario_Status)
            VALUES(:zname, :zdesc, :zcomp, now(), :zstate)");

            $stmt->execute(array(
            'zname' => $username,
            'zdesc' => $text,
            'zcomp' => $campaign,
            'zstate' => 0,
            ));
            return true;
        }

    }

    public function UpdateScenario($username, $text, $campaign, $scenarioid) {

        // chekc if scenario exist 
        $statement = $this->db->prepare("SELECT scenario_ID FROM scenario WHERE scenario_ID = ?");
		$statement->execute(array($scenarioid));
        $count = $statement->rowCount();
        
        if ($count < 0) {
            $field = "general";
            Form::setError($field, "This Scenario did not exist, Try Again Pls!!");
        }
        
        //chekc if username already exist
        $count = $this->db->prepare("SELECT COUNT('scenario_ID') FROM scenario WHERE scenario_Name = ? AND scenario_campaign_ID = ? AND scenario_ID != ?");

		$count->execute(array($username,$campaign, $scenarioid));
        $check = $count->fetchColumn();
        
        if ($check > 0) {
            $field = "edit_sc_username";
            Form::setError($field, "This Scenario Name already choosed for this campaign try new one to not conflit");
        }

        /* Errors exist, have user correct them */
        if (Form::$num_errors > 0) {
            return false;  //Errors with form
        } else {
            // Insert Scenario In Database
            $stmt = $this->db->prepare("UPDATE scenario SET scenario_Name = ? , scenario_Text = ?, scenario_campaign_ID = ? WHERE scenario_ID = ? ");

            $stmt->execute(array($username, $text, $campaign, $scenarioid));
            return true;
        }

    }

    function returnScenarioInfo($id) {
        $sql = $this->db->query("SELECT * FROM `scenario` WHERE scenario_id = '$id'");
        return $scenarioinfo = $sql->fetch();
    }

    public function checkforemptyScenario($username, $text, $campaign,$option) {
        // $scenariofunctions->RegisterNewScenario($name, $desc, $camp);
        if(empty($username)) {
            $field = $option."_sc_username";
            Form::setError($field, "Scenario Name can not be empty 2");
        } 
        if(empty($text)) {
            $field = $option."_sc_textdesc";
            Form::setError($field, "Scenario Text can not be empty");
        } 
        if(empty($campaign) || $campaign <= 0) {
            $field = $option."_sc_campaign";
            Form::setError($field, "Choose Campaign for Scenario to complete");
        }
        /* Errors exist, have user correct them */
        if (Form::$num_errors > 0) {
            return false;  //Errors with form
        } else {
            return true;
        }
    }

}