<?php

include_once 'controller.php';

if (!$session->isAdmin()) {
    header("Location: " . $configs->homePage());
    exit;
}

$form_submission = (isset($_POST['form_submission'])) ? $_POST['form_submission'] : $_GET['form_submission'];

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    if (isset($_POST['action']) && $_POST['action'] == 'manageChart') {
        switch ($form_submission) {
            case "chart_reports_management" :
                ChartReports($db, $session);
                break;
            default :
                header("Location: ../index.php");
        }
    } else {
        header("Location: ../index.php");
    }
} else {
    header("Location: ../index.php");
}

/**
 * ********************************************************************************************************
 * deleteInactive - All inactive users are deleted from the database, not including administrators. 
 * Inactivity is defined by the number of days specified that have gone by that the user has not logged in.
 * ********************************************************************************************************
 */
function ChartReports($db, $session) {
    $adminid = $session->id;
    $dateid = 0;
    $userid = 0;
    $campaignid = 0;

    // Check If Get Request Catid Is Numeric & Get The Integer Value Of It 
    $campaignid = $_POST['chart_campaign'];
    $userid = $_POST['chart_user'];
    $dateid = $_POST['chart_date'];

    
    if($campaignid != 0) {
        $compaignCond = 'AND mail_campaign =' . $campaignid ;
    } else {
        $compaignCond = '';
    }
    if($userid != 0) {
        $userCond = 'AND mail_user =' . $userid ;
    } else {
        $userCond = '';
    }
    
    // Date Used 
    date_default_timezone_set('Europe/London'); 
    
    $end_date = date('Y-m-d');

    if($dateid == '1') { 
        $start_date = date('Y-m-d', strtotime('-1 month'));
    } elseif($dateid == '2') { 
        $start_date = date('Y-m-d', strtotime('-6 month'));
    } elseif($dateid == '3') { 
        $start_date = date('Y-m-d', strtotime('-12 month'));
    } elseif($dateid == '0') { 
        $start_date = date('Y-m-d', strtotime('-7 day'));
    }
    
    // BETWEEN $start_date AND $end_date 
    $stmt = $db->prepare("SELECT
            mails.mail_campaign, 
            mails.mail_date_finished,
            count(mail_id),
            campaign.campaign_Creator
        FROM 
            mails 
        INNER JOIN 
            campaign 
        ON 
            campaign.campaign_ID = mails.mail_campaign
        WHERE
            mails.mail_state = 1
            AND 
            mails.mail_date_finished >= '$start_date'
            AND 
            mails.mail_date_finished <= '$end_date' 
            $compaignCond 
            $userCond
        GROUP BY 
            mails.mail_date_finished"); 


    $stmt->execute();
    
    $chart = $stmt->fetchAll();

    // echo $start_date . $end_date;
    echo json_encode($chart);

}

