<?php

include_once 'controller.php';
require_once "PHPExcel/Classes/PHPExcel.php";

if (!$session->logged_in) {
    header("Location: " . $configs->homePage());
    exit;
}

$form_submission = (isset($_POST['form_submission'])) ? $_POST['form_submission'] : $_GET['form_submission'];
switch ($form_submission) {
    case "mails_registration" :
        Registermails($db, $mails, $session);
        break; 
    case "mails_checker" :
        CheckOpenmails($db, $mails, $session);
        break; 
    case "add_new_mail" :
        AddNewemail($db, $mails);
        break; 
    case "delete_mail_account" :
        Deleteemail($db);
        break; 
    case "scan_mail_state":
        DefaultState($db);
        break; 
    default :
        header("Location: ../mails-list.php");
    
}

/**
 * ********************************************************************************************************
 * Register mails.
 * ********************************************************************************************************
 */
function Registermails($db, $mails, $session) {
    
    ini_set('max_execution_time', 0);
    // Import CSV File
    $user = $session->id; 
    $fileName = $_FILES["file"]["tmp_name"];
    $campaignName = $_POST['FileCampaign'];
    $TypeFile = $_POST['csvType'];
    $mailtext = $_POST['mailtext'];
    $websitename = $_POST['websitename'];

    if(empty($TypeFile)) {
        $field = "mails";
        Form::setError($field, "There is error with file type try again");
        $_SESSION['value_array'] = $_POST;
        $_SESSION['error_array'] = Form::getErrorArray();
        header("Location: ../mails-list.php");
        return false;  //Errors with form
    } else if($TypeFile == 'listmails') {
        
        $mails->checkforemptyCamp($campaignName, $fileName);
        $mails->checkforemptyMails($campaignName, $fileName);

        /* Errors exist, have user correct them */
        if (filesize($fileName) <= 0) {

            $field = "mails";
            Form::setError($field, "This file Is empty");
            $_SESSION['value_array'] = $_POST;
            $_SESSION['error_array'] = Form::getErrorArray();
            header("Location: ../mails-list.php");
            return false;  //Errors with form

        } else if (Form::$num_errors > 0) {

            $_SESSION['value_array'] = $_POST;
            $_SESSION['error_array'] = Form::getErrorArray();
            header("Location: ../mails-list.php");
            return false;  //Errors with form

        } else { 
            $excelReader = PHPExcel_IOFactory::createReaderForFile($fileName);
            $excelObj = $excelReader->load($fileName);
            $worksheet = $excelObj->getSheet(0);
            $lastRow = $worksheet->getHighestRow();

            // echo "<table>";
            for ($row = 1; $row <= $lastRow; $row++) {
                $colmailstate = $worksheet->getCell('B'.$row)->getValue();  
                $colmail = $worksheet->getCell('C'.$row)->getValue();  
                $colurl = $worksheet->getCell('E'.$row)->getValue(); 
                $colAuthor = $worksheet->getCell('F'.$row)->getValue(); 
                $colrating = $worksheet->getCell('G'.$row)->getValue(); 
                $colreferring = $worksheet->getCell('H'.$row)->getValue(); 
                $coltraffic = $worksheet->getCell('I'.$row)->getValue(); 
                $coltrafficvalue = $worksheet->getCell('J'.$row)->getValue(); 
                $datenow = date("Y-m-d H:i:s"); 
                if(strtolower($colmailstate) == 'completed') {
                    $colmailstate = 0;
                } else {
                    $colmailstate = 1;
                }
                if(!empty($colmail)) {  
                    $col = urlencode($colurl);
                    $col = str_replace('%00', '', $col);
                    $query[] = '('  . "'$colmail'" . ',' 
                                    . "'$colAuthor'" . ','
                                    . $colrating . ',' 
                                    . $colreferring . ',' 
                                    . $coltraffic . ',' 
                                    . $coltrafficvalue . ',' 
                                    . $colmailstate . ',' 
                                    . "'$col'" . ',' 
                                    . "'$datenow'" . ',' 
                                    .  $campaignName . ')'; 
                }
            }
            
            // remove first row file header
            $query2 = array_shift($query);
            $Insertedquery2 = "INSERT INTO mails(mail_text, mail_author, domain_rating, referring_domains, traffic, traffic_value, mail_state, mail_url, mail_date_add, mail_campaign) VALUES";
            if(count($query) > 0) {  
                $Insertedquery2 .= implode(',', $query); 
                $stmt = $db->prepare($Insertedquery2);  
                // print_r($Insertedquery2);
                if($stmt->execute()) { 
                    $field = "general";
                    Form::setError($field, "emails added succesfully");
                    $_SESSION['value_array'] = $_POST;
                    $_SESSION['error_array'] = Form::getErrorArray();
                } else {
                    $field = "mails";
                    Form::setError($field, "mails Not Imported Try Again");
                    $_SESSION['value_array'] = $_POST;
                    $_SESSION['error_array'] = Form::getErrorArray();
                    return false;  //Errors with form
                }  
            } 
            header("Location: ../mails-list.php");
        }// STATEMENT 
    } 
}


function CheckOpenMails($db, $mail, $session) {

    $date = date('Y-m-d H:i:s', strtotime('-30 minutes'));

    $stmt = $db->prepare("SELECT *  FROM mails WHERE mail_manage = 1 AND mail_time_open < ?");
    $stmt->execute(array($date));

    // Assign To Variable  
    $mails2 = $stmt->fetchAll();

    if(empty($mails2)) {
        header("Location: ../linkChecker.php");
    } else {
        $stmt2 = $db->prepare("UPDATE mails SET mail_manage = 0 WHERE mail_manage = 1 AND mail_time_open < ?");
        $stmt2->execute(array($date));
        header("Location: ../linkChecker.php");
    }
}

/**
 * *********************************************
 * Add New Email Account
 * *********************************************
 */
function AddNewemail($db, $mails) {
    $email = $_POST['account_email'];
    $pass = $_POST['account_pass'];

    if (!$email || strlen($email = trim($email)) == 0) {
        $field = "mail_email";  //Use field for username
        Form::setError($field, "Email not entered");
    }  else if(!$pass) {
        $field = "mail_pass";  //Use field for password
        Form::setError($field, "Password not entered");
    } else if(!filter_var($email, FILTER_VALIDATE_EMAIL)) {
        $field = "mail_email";  //Use field for username
        Form::setError($field, "is not a valid email address");
    }

    /* Errors exist, have user correct them */
    if (Form::$num_errors > 0) {
        $_SESSION['value_array'] = $_POST;
        $_SESSION['error_array'] = Form::getErrorArray();
        header("Location: " . $_SERVER['REQUEST_URI']);
        return false;
    } else {
        /* Check if mail exist */
        $result = $db->query("SELECT mail_id FROM used_mails WHERE mail_email = '$email'");
        $count = $result->rowCount();
        $field = "mail_email"; 
        if ($count > 0) {
            Form::setError($field, "Email Already exist");
            $_SESSION['value_array'] = $_POST;
            $_SESSION['error_array'] = Form::getErrorArray();
            header("Location: " . $_SERVER['REQUEST_URI']);
            return false;
        } else {
            $mails->addmail($email,$pass);
            header("Location: ../used-mails.php");
            return false;
        }
    }
}
/**
 * *********************************************
 * Delete email Account
 * *********************************************
 */
function Deleteemail($db) {
    $id = $_POST['mail_action']; 

    if (!$id) {
        $field = "general";  //Use field for username
        Form::setError($field, "There is something wrong when we try delete this email pls try again");
    } 
    if (Form::$num_errors > 0) {
        $_SESSION['value_array'] = $_POST;
        $_SESSION['error_array'] = Form::getErrorArray();
        header("Location: ../used-mails.php");
        return false;
    } else {
        /* Check if mail exist */
        $query = $db->query("DELETE FROM used_mails WHERE mail_id = $id");
        if($query->execute()) {
            $field = "success";  //Use field for username
            Form::setError($field, "Account deleted successfuly !!");
            $_SESSION['value_array'] = $_POST;
            $_SESSION['error_array'] = Form::getErrorArray();
            header("Location: ../used-mails.php");
            return true;
        }
    }
}

/**
 * *********************************************
 * Scane mails Skiped
 * *********************************************
 */
function DefaultState($db) {
    date_default_timezone_set('Europe/London'); 
	$date = date('Y-m-d H:i:s', strtotime('-10 minutes'));

	$stmt = $db->prepare("SELECT mail_id FROM mails WHERE mail_manage = 1 AND mail_time_open < ?");
	$stmt->execute(array($date));

	// Assign To Variable  
	$mails2 = $stmt->fetchAll();

	if(empty($mails2)) {
        $field = "success";  //Use field for username
        Form::setError($field, "There is no Links to update for moment");
        $_SESSION['value_array'] = $_POST;
        $_SESSION['error_array'] = Form::getErrorArray();
        header("Location: ../index.php");
        return true;
	} else {
		$stmt2 = $db->prepare("UPDATE mails SET mail_manage = 0 WHERE mail_manage = 1 AND mail_time_open < ?");
		$stmt2->execute(array($date));
		$field = "success";  //Use field for username
        Form::setError($field, "mails updated successfully");
        $_SESSION['value_array'] = $_POST;
        $_SESSION['error_array'] = Form::getErrorArray();
        header("Location: ../index.php");
        return true;
	}
}