<?php

include_once 'controller.php';


if (!$session->isAdmin()) {
    header("Location: " . $configs->homePage());
    exit;
}

$form_submission = (isset($_POST['form_submission'])) ? $_POST['form_submission'] : $_GET['form_submission'];
switch ($form_submission) {
    case "scenario_registration" :
        RegisterScenario($db, $scenarios, $session);
        break;
    case "edit_scenario" :
        EditScenario($db, $scenarios);
        break;
    case "filter_scenario" :
        FilterScenario($scenarios);
        break;
    case "manage_scenario" :
        if (isset($_POST['button']) && ($_POST['button'] == "Deactivate")) {
            DeactivateScenario($db, $functions, $session);
        } else
        if (isset($_POST['button']) && ($_POST['button'] == "Activate")) {
            ActivateScenario($db, $functions, $session);
        } else
        if (isset($_POST['button']) && ($_POST['button'] == "Delete")) {
            deleteScenario($db, $functions, $session);
        }
        break;
    default :
        header("Location: ../scenarios.php");
    
}

function FilterScenario($scenarios) {

    $camp = $_POST['scenario_campaign'];

    $scenarios = $scenarios->fetchScenarios($camp);
    return $scenarios;
    header("Location: ../scenarios.php");
}
/**
 * ********************************************************************************************************
 * deleteInactive - All inactive users are deleted from the database, not including administrators. 
 * Inactivity is defined by the number of days specified that have gone by that the user has not logged in.
 * ********************************************************************************************************
 */
function RegisterScenario($db, $scenarios, $session) {
    
    // Get Variables From The Form
    $name = $_POST['scenario_name'];
    $desc = $_POST['scenario_text'];
    $camp = $_POST['scenario_campaign'];
    $option = "add";

    $scenarios->checkforemptyScenario($name, $desc, $camp,$option);

    /* Errors exist, have user correct them */
    if (Form::$num_errors > 0) {
        $field = "addform";
        Form::setError($field, "add form error");
        $_SESSION['value_array'] = $_POST;
        $_SESSION['error_array'] = Form::getErrorArray();
        header("Location: ../scenarios.php");
        return false;  //Errors with form
        
    } else {
        $scenarioo = $scenarios->RegisterNewScenario($name, $desc, $camp);

        if ($scenarioo) {
            header("Location: ../scenarios.php");
        }
        else {
            $_SESSION['value_array'] = $_POST;
            $_SESSION['error_array'] = Form::getErrorArray();
            header("Location: ../scenarios.php");
        }
    }
    
}

function EditScenario($db, $scenarios) {
    
    // Get Variables From The Form
    $name = $_POST['scenario_name'];
    $desc = $_POST['scenario_text'];
    $camp = $_POST['scenario_campaign'];
    $scenarioid = $_POST['scenario_to_edit'];
    $option = "edit";

    $scenarios->checkforemptyScenario($name, $desc, $camp,$option);

    /* Errors exist, have user correct them */
    if (Form::$num_errors > 0) { 
        $field = "editform";
        Form::setError($field, "edit form error");
        $field = "scenarioid";
        Form::setError($field, $scenarioid);
        $_SESSION['value_array'] = $_POST;
        $_SESSION['error_array'] = Form::getErrorArray();
        header("Location: ../scenarios.php");
        return false;  //Errors with form
    } else {
        $scenarioo = $scenarios->UpdateScenario($name, $desc, $camp, $scenarioid);

        if ($scenarioo) {
            header("Location: ../scenarios.php");
        }
        else {
            $_SESSION['value_array'] = $_POST;
            $_SESSION['error_array'] = Form::getErrorArray();
            header("Location: ../scenarios.php");
        }
    }

}

function deleteScenario($db, $functions, $session) {
    /* Username error checking */
    $deleted_scnario = $_POST['scenariotoedit'];

    // Select All Data Depend On This ID
    $check = $functions->checkItem('scenario_ID', 'scenario', $deleted_scnario);

     // If There's Such ID Show The Form 
    if ($check > 0) {
        /* Ban user from member system */
        $sql = $db->prepare("DELETE FROM `scenario` WHERE `scenario_ID` = ?");
        $sql->execute(array($deleted_scnario));
        
        header("Location: ../scenarios.php");
        
    } else {
        header("Location: ../scenarios.php");
        exit;
    }
}

function DeactivateScenario($db, $functions, $session) {
    /* Username error checking */
    $selected_scnario = $_POST['scenariotoedit'];

    // Select All Data Depend On This ID
    $check = $functions->checkItem('scenario_ID', 'scenario', $selected_scnario);

     // If There's Such ID Show The Form 
    if ($check > 0) {
        /* Ban user from member system */
        $sql = $db->prepare("UPDATE scenario SET scenario_Status = ? WHERE scenario_ID = ?");
        $sql->execute(array(1,$selected_scnario));
        
        header("Location: ../scenarios.php");
        
    } else {
        header("Location: ../scenarios.php");
        exit;
    }
}

function ActivateScenario($db, $functions, $session) {
    /* Username error checking */
    $selected_scnario = $_POST['scenariotoedit'];

    // Select All Data Depend On This ID
    $check = $functions->checkItem('scenario_ID', 'scenario', $selected_scnario);

     // If There's Such ID Show The Form 
    if ($check > 0) {
        /* Ban user from member system */
        $sql = $db->prepare("UPDATE scenario SET scenario_Status = ? WHERE scenario_ID = ?");
        $sql->execute(array(0,$selected_scnario));
        
        header("Location: ../scenarios.php");
        
    } else {
        header("Location: ../scenarios.php");
        exit;
    }
}