<?php
include_once "includes/controller.php";

$pagename = 'mailslist';
$container = '';
$pageTitle = "manage mails";

include_once "includes/init.php";

$form = new Form;

if (!$session->isAdmin()) {
    header("Location: " . $configs->homePage());
    exit;
} else {
?>
<!-- Page Wrapper -->
<div id="page-wrapper">
  <?php include 'theme/templates/navbar.php';?>

  <!----------------------------------- Page Content -------------------------------------->
  <div class="kt-grid__item kt-grid__item--fluid kt-grid kt-grid--ver kt-grid--stretch">
    <div class="kt-container kt-body  kt-grid kt-grid--ver" id="kt_body">
      <div class="kt-grid__item kt-grid__item--fluid kt-grid kt-grid--hor">

        <!-- begin:: Content Head -->
        <div class="kt-subheader kt-grid__item" id="kt_subheader">
          <div class="kt-subheader__main">
            <h3 class="kt-subheader__title">
              <span class="flaticon-message kt-padding-l-20"></span> mails
            </h3>
          </div>
          <div class="kt-subheader__toolbar">
            <div class="kt-subheader__wrapper">
              <div class="btn-group">
              <a data-target='#Addmails' data-type="Addlistmails" data-toggle='modal' class="open_modal kt-padding-l-20 kt-padding-r-5 btn btn-brand text-white">
                <span data-toggle="kt-popover" title="file demo on drive"
                  data-content="check file on drive Example Columns for Dahir ">
                  <i class="kt-nav__link-icon flaticon-file-1"></i>
                  <span class="kt-nav__link-text kt-padding-l-5">add list of mails</span>
                </span>
              </a>
              </div>
            </div>
          </div>
        </div>
        <!-- end:: Content Head -->

        <?php if (!empty(Form::error("general")))  {?>
        <div class="alert alert-success kt-margin-b-20" role="alert">
          <div class="alert-text"><?php echo Form::error("general"); ?></div>
        </div>
        <?php } ?>
        <?php if (!empty(Form::error("mails")))  {?>
        <div class="alert alert-danger kt-margin-b-20" role="alert">
          <div class="alert-text"><?php echo Form::error("mails"); ?></div>
        </div>
        <?php } ?>

        <!-- Modal Add mail -->
        <div class="modal fade" id="Addmails" tabindex="-1" role="dialog" aria-labelledby="Addmails" aria-hidden="true">
          <div class="modal-dialog" id="modal-info">
            <!-- Content is dynamically pulled from editcampaign.php -->
            <div class="modal-content" id="mailslist">
              <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLabel"> Add New Mail </h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                </button>
              </div>
              <form action="includes/mailsprocess.php" id="frmCSVImport" class="form-horizontal" method="post"
                enctype="multipart/form-data">
                <div class="modal-body">

                  <div class="form-group" id="dragFile">
                    <label for="scenario_text" class="control-label"> Mails File : </label>

                    <div class="upload-files-drop">
                      <input type="file" name="file" id="file" accept=".xlsx" class="required inputfile">
                      <label class="uppy-DashboardTabs">
                        <span class="uppy-Dashboard-dropFilesTitle"> Drop file here </span>
                      </label>
                    </div> 
                  </div>

                  <div class="form-group" id="NormalUpload">
                    <div class="kt-margin-b-20">
                      <label for="mailtext" class="form-control-label"> mail text :</label>
                      <input type="mail" id="mailtext" name="mailtext" class="form-control required" />
                    </div>
                    <div class="kt-margin-b-20">
                      <label for="mailtext" class="form-control-label">website url :</label>
                      <input type="text" id="websitename" name="websitename" class="form-control required" /> 
                    </div>
                  </div>

                  <div class="form-group">
                    <label for="add-user" class="control-label"> Choose Campaign : </label>
                    <select for="add-user" name="FileCampaign" class="form-control chosen-select selectpicker" data-placeholder="Click here..">
                      <?php 
                        $allCampaigns = $campaigns->fetchCampaigns();
                        echo "<option value='0'> Choose Campaign </option>";
                        foreach ($allCampaigns as $campaign) {
                          echo "<option value='" . $campaign['campaign_ID'] . "'>" . $campaign['campaign_Name'] . "</option>"; 
                        }
                      ?>
                    </select>
                    <small class="form-text text-muted kt-font-danger"><?php echo Form::error("campaign"); ?></small>
                  </div>

                </div>

                <input type="hidden" name="form_submission" value="mails_registration" />
                <input type="hidden" name="csvType" id="scsvTypeFile" value="listmails" />

                <div class="modal-footer">
                  <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                  <button type="submit" class="btn btn-primary" id="submit">upload</button>
                </div>
              </form>
            </div>
          </div>
        </div>
        <!-- End Modals-->

        <!--Begin::Section-->
        <div class="row">
          <div class="col-xl-12">
            <div class="list-head-btn kt-portlet kt-portlet--height-fluid kt-portlet--mobile">
              <div class="kt-portlet__head kt-portlet__head--lg kt-portlet__head--break-sm">
                <div class="kt-portlet__head-label">
                  <span class="kt-portlet__head-icon">
                    <i class="kt-font-brand flaticon-stopwatch"></i>
                  </span>
                  <h3 class="kt-portlet__head-title"> Manage Mails Lists </h3>
                </div>
                <div class="kt-portlet__head-toolbar">
                  <div class="kt-subheader__group kt-hidden d-flex align-items-center" id="kt_subheader_group_actions">
                    <div class="kt-subheader__desc font-bold">
                      <span id="kt_subheader_group_selected_rows"></span> Selected:
                    </div>
                    <!-- Delete btn -->
                    <div class="btn-toolbar kt-margin-l-20">
                      <button class="kt-margin-l-5 btn btn-label-danger btn-bold btn-sm btn-icon-h"
                        id="kt_subheader_group_actions_delete_all">
                        Delete All
                      </button>
                    </div>
                  </div>
                </div>
              </div>

              <div class="kt-portlet__body kt-portlet__body--fit">

              </div>
            </div>
          </div>
        </div>
        <!--End::Section-->
      </div>
    </div>
  </div>
  <!----------------------------------- ./End Page Content -------------------------------------->
</div>
<!-- END Page Wrapper -->

<?php include $tpl . 'footer.php';?>

<!-- This dynamically loads the Modal with the Group Info -->
<script>
  $(document).ready(function () {
    $(".kt-portlet__body").load("mails-list-table.php");
  });
  
  $(document).on("click", ".open_modal", function () {
    var mailstype = $(this).data('type');
    $('#NormalUpload').hide();
    $('#dragFile').hide();
    if (mailstype == 'Addlistmails') {
      $('#scsvTypeFile').val("listmails");
      $('#dragFile').show();
      $("#modal-info #mailslist").show();
    } else if (mailstype == 'Addnormalmails') {
      $('#scsvTypeFile').val("normalmail");
      $('#NormalUpload').show();
      $("#modal-info #mailtext").show();
    }
  });

  $(document).ready(function () {
    $("#frmCSVImport").on("submit", function (e) {
      if ($('#scsvTypeFile').val() == "listmails") {
        var fileType = ".xlsx";
        var regex = new RegExp("([a-zA-Z0-9\s_\\.\-:])+(" + fileType + ")$");
        if ($("#file").val() == '') {
          Swal.fire({
            type: 'error',
            title: 'Oops...',
            text: "Empty File."
          });
          return false;
        } else if (!regex.test($("#file").val().toLowerCase())) {
          Swal.fire({
            type: 'error',
            title: 'Oops...',
            text: "Invalid File. Upload : <b>" + fileType + "</b> Files."
          });
          return false;
        } else if ($('#form-stacked-cat').val() == 0) {
          Swal.fire({
            type: 'error',
            title: 'Oops...',
            text: "Campaign Name is empty"
          });
          return false;
        }
        return true
      } else {
        return true
      }
    });
  });

  //file upload 
  (function (document, window, index) {
    var inputs = $('.inputfile');
    Array.prototype.forEach.call(inputs, function (input) {
      var label = input.nextElementSibling,
        labelVal = label.innerHTML;

      input.addEventListener('change', function (e) {
        var fileName = '';
        fileName = e.target.value.split('\\').pop();

        if (fileName)
          label.querySelector('span').innerHTML = fileName;
        else
          label.innerHTML = labelVal;
      });

      // Firefox bug fix
      input.addEventListener('focus', function () {
        input.classList.add('has-focus');
      });
      input.addEventListener('blur', function () {
        input.classList.remove('has-focus');
      });
    });
  }(document, window, 0));
</script>

<!--ADD PERFECT SCROLLBAR TO CONTAINER-->
<!-- <script src="<?php echo $js ?>mails-table.js" type="text/javascript"></script> -->
</body>

</html>
<?php
}
?>