<?php
include_once "includes/controller.php";

$pagename = 'scenarios';
$container = '';
$pageTitle = "manage scenarios";

include_once "includes/init.php";

$form = new Form;

if (!$session->isAdmin()) {
    header("Location: " . $configs->homePage());
    exit;
} else {

    ?>
    <!-- Page Wrapper -->
    <div id="page-wrapper">
      <?php include 'theme/templates/navbar.php';?>

        <!----------------------------------- Page Content -------------------------------------->
        <div class="kt-grid__item kt-grid__item--fluid kt-grid kt-grid--ver kt-grid--stretch">
          <div class="kt-container kt-body  kt-grid kt-grid--ver" id="kt_body">
            <div class="kt-grid__item kt-grid__item--fluid kt-grid kt-grid--hor">

            <!-- begin:: Content Head -->
            <div class="kt-subheader kt-grid__item" id="kt_subheader">
              <div class="kt-subheader__main">
                <h3 class="kt-subheader__title"> 
                  <span class="flaticon-mail kt-padding-l-10"></span> Scenarios
                </h3>
              </div>
              <div class="kt-subheader__toolbar">
                <div class="kt-subheader__wrapper">
                <button type="button" data-toggle="modal" data-target="#createScenario" class="btn btn-primary btn-bold btn-sm btn-icon-h kt-margin-l-10">
                    <i class="flaticon2-plus"></i> Create Scenario
                  </button>
                </div>
              </div>
            </div>
            <!-- end:: Content Head -->

            <?php if(Form::error("general")) { echo "<div class='kt-alert kt-alert--outline alert alert-danger alert-dismissible' id='user-error'>".Form::error('general')."</div>"; } ?>
            
            <div class="row">
              <div class="col-12">
                <div class="kt-portlet kt-portlet--mobile">
                
                  <div class="kt-portlet__head kt-portlet__head--lg">
                    <div class="kt-portlet__head-label">
                      <span class="kt-portlet__head-icon">
                        <i class="kt-font-brand flaticon-tabs"></i>
                      </span>
                      <h3 class="kt-portlet__head-title">
                        Manage Scenarios
                      </h3>
                    </div>
                    <div class="kt-portlet__head-toolbar">
                      <div class="kt-portlet__head-wrapper">
                        <div class="kt-portlet__head-actions"> 
                          <!-- Filter Scenario Using Campaign -->  
                          <div class="right-dropdown" id="right-dropdown">
                            <select for="add-user" name="scenario_campaign" class="btn-w-300 form-control chosen-select scenario-select" id="filter_Scenario" data-dropdown-align-right="true" data-placeholder="filter Scenarios..">
                              <?php 
                                $allCampaigns = $campaigns->fetchCampaigns();
                                echo "<option value='0'> All Campaign </option>";
                                foreach ($allCampaigns as $campaign) {
                                  echo "<option value='" . $campaign['campaign_ID'] . "'>" . $campaign['campaign_Name'] . "</option>"; 
                                }
                              ?>
                            </select>
                          </div> 
                        </div>
                      </div>
                    </div>
                  </div>

                  <div class="kt-portlet__body" id="kt-portlet__body-scenario">
                    
                  </div>
                  
                  </div>
                </div>
              </div>
              <!-- END Row -->

                <!--  Modals -->
								<div class="modal fade" id="createScenario" tabindex="-1" role="dialog" aria-labelledby="createScenario" aria-hidden="true">
									<div class="modal-dialog" role="document">
										<div class="modal-content">
											<div class="modal-header">
                        <h5 class="modal-title" id="createGroup">Create a New Scenario</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        </button>
											</div>
											<form action="includes/scenarioprocess.php" id="scenario-create" class="form-horizontal" method="post"> 
												<div class="modal-body">
													<div class="form-group <?php if (Form::error("add_sc_username")) {echo 'has-error';}?>">
														<label for="scenario_name" class="control-label">New Scenario Name : </label>
                            <input type="text" id="scenario_name" name="scenario_name" class="form-control" placeholder="Scenario Name" />
                            <small class="form-text text-muted kt-font-danger"><?php echo Form::error("add_sc_username"); ?></small>
                          </div>
                          <div class="form-group">
                            <label for="add-user" class="control-label"> Scenario Campaign : </label>
                            <select for="add-user" name="scenario_campaign" class="form-control chosen-select selectpicker <?php if (Form::error("add_sc_campaign")) {echo 'has-error';}?>" data-placeholder="Choose Camapign.." required>
                            <?php 
                              $allCampaigns = $campaigns->fetchCampaigns();
                              echo "<option value='0' selected='selected'> Choose Campaign </option>";
                              foreach ($allCampaigns as $campaign) {
                                echo "<option value='" . $campaign['campaign_ID'] . "'>" . $campaign['campaign_Name'] . "</option>"; 
                              }
                            ?>
                            </select>
                            <small class="form-text text-muted kt-font-danger"><?php echo Form::error("add_sc_campaign"); ?></small>
                          </div>
													<div class="form-group <?php if (Form::error("add_sc_textdesc")) {echo 'has-error';}?>">
														<label for="scenario_text" class="control-label">New Scenario Text : </label>
                            <textarea id="scenario_text" name="scenario_text" rows="8" class="form-control" placeholder="Scenario text"></textarea>
                            <small class="form-text text-muted kt-font-danger"><?php echo Form::error("add_sc_textdesc"); ?></small>
													</div>
                        </div>
                        <input type="hidden" name="form_submission" value="scenario_registration">
												<div class="modal-footer">
														<button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
														<button type="submit" class="btn btn-primary" id="add_new_scenario">Create Scenario</button>
												</div>
											</form>
										</div>
									</div>
								</div>

                <div class="modal fade" id="editScenarios" tabindex="-1" role="dialog" aria-labelledby="editScenarios" aria-hidden="true">
                    <div class="modal-dialog" id="modal-info">
                        <!-- Content is dynamically pulled from editgroup.php -->
                    </div>
                </div>
                <!-- End Modals-->

            </div>

            </div>
          </div>
        </div>
        <!-- END Page Content -->

			</div>
			<!-- END Page Wrapper -->

  <?php include $tpl . 'footer.php';?>
  
  <!-- Show modal depend in situation -->
  <?php if (!empty(Form::error("addform"))) { ?>
    <script>
      $('#createScenario').modal('show');
    </script>
  <?php } if (!empty(Form::error("editform"))) { 
    echo "<input type='hidden' value='". Form::error("scenarioid"). "' id='wpen-scenario_id' />";
    echo "<div id='conetntmsg' class='kt-hidden'>" . Form::error("edit_sc_username") ."<br>". Form::error("edit_sc_textdesc") ."<br>". Form::error("edit_sc_campaign"). "</div>";
    ?> 
    <script>
    var $content = $('#conetntmsg').html();
      Swal.fire({
        type: 'error',
        title: 'Oops...',
        html: "<p class='kt-font-danger'>" + $content + "</p>",
      }).then((result) => {
          $('#editScenarios').modal('show');
          var $group_id = $('#wpen-scenario_id').val(); 
          $("#modal-info").load("editscenario.php?log_id=" + $group_id);
      });
    </script>
  <?php } ?>

  <script type="text/javascript">
  console.log("fuck"); 
    $('.confirmation').on('click', function () {
      return confirm('Are you sure you wish to delete this scenario?.');
    }); 

    //  This dynamically loads the Modal with the Group Info 
    $(document).on("click", ".open_modal", function () {
      var group_id = $(this).data('logid');
      $("#modal-info").load("editscenario.php?log_id=" + group_id);
    }); 
    $(document).ready(function() {
      $("#kt-portlet__body-scenario").load("scenarioTable.php");
      console.log("fuck");
    });
    $(document).on("change", "#filter_Scenario", function () {
        var group_id = $(this).val();
        $("#kt-portlet__body-scenario").load("scenarioTable.php?log_id=" + group_id);
    }); 
  </script>
<?php
}
?>
</body>
</html>