<?php
include_once "includes/controller.php";

$pagename = 'users';
$container = '';
$pageTitle = "manage users";

include_once "includes/init.php";

$form = new Form;

if (!$session->isAdmin()) {
    header("Location: " . $configs->homePage());
    exit;
} else {

  ?>
<!-- Page Wrapper -->
<div id="page-wrapper">
  <?php include 'theme/templates/navbar.php';?>

  <!----------------------------------- Page Content -------------------------------------->
  <div class="kt-grid__item kt-grid__item--fluid kt-grid kt-grid--ver kt-grid--stretch">
    <div class="kt-container kt-body  kt-grid kt-grid--ver" id="kt_body">
      <div class="kt-grid__item kt-grid__item--fluid kt-grid kt-grid--hor">

        <!-- begin:: Subheader -->
        <div class="kt-subheader kt-grid__item" id="kt_subheader">
          <div class="kt-subheader__main">
            <h3 class="kt-subheader__title"> 
            <span class="flaticon-user kt-padding-l-10"></span> Users
            </h3>
          </div>
          <div class="kt-subheader__toolbar">
            <button type="button" data-toggle="modal" data-target="#createUser" class="btn btn-primary btn-bold btn-sm btn-icon-h kt-margin-l-10">
              <i class="flaticon2-plus"></i> Add user
            </button>
          </div>
        </div>
        <!-- end:: Subheader -->

        <!-- begin:: Content -->
        <div class="row">
          <div class="col-12">
            <div class="kt-portlet kt-portlet--mobile">
              <div class="kt-portlet__head kt-portlet__head--lg">
                <div class="kt-portlet__head-label">
                  <span class="kt-portlet__head-icon">
                    <i class="kt-font-brand flaticon2-avatar"></i>
                  </span>
                  <h3 class="kt-portlet__head-title">
                    User's Management
                  </h3>
                </div>
              </div>

              <div class="kt-portlet__body">

                <!--begin: Datatable -->
                <?php include './users/activeUsers.php';?>
                <!--end: Datatable -->

              </div>
            </div>
          </div>
        </div>

        <!-- Modal -->
        <div class="modal fade" id="createUser" class="modal" tabindex="-1" role="dialog" aria-labelledby="createUser"
          aria-hidden="true">
          <div class="modal-dialog">
            <div class="modal-content" id="modal-content">
              <form class="form-horizontal" id="admin-create-user" action="includes/adminprocess.php" method="POST"
                role="form">
                <div class="modal-header">
                  <h4 class="modal-title" id="myModalLabel">Create New User</h4>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close"></button>
                </div>

                <div class="kt-scroll" data-scroll="true">
                  <div class="modal-body kt-p20">
                    <div class="form-group <?php if (Form::error("user")) {echo 'has-error';}?>">
                      <label for="inputUsername">Username:</label>
                      <input name="user" type="text" class="form-control" id="inputUsername" placeholder="Username"
                        value="<?php echo Form::value("user"); ?>">
                      <small class="form-text text-muted kt-font-danger"><?php echo Form::error("user"); ?></small>
                    </div>
                    
                    <div class="form-group <?php if (Form::error("firstname")) {echo 'has-error';}?> ">
                      <label for="inputFirstname">First Name:</label>
                      <input type="text" name="firstname" class="form-control" id="inputFirstname" placeholder="First Name"
                        value="<?php echo Form::value("firstname"); ?>">
                      <small class="form-text text-muted kt-font-danger"><?php echo Form::error("firstname"); ?></small>
                    </div>

                    <div class="form-group <?php if (Form::error("lastname")) {echo 'has-error';}?>">
                      <label for="inputLastname">Last Name:</label>
                      <input type="text" name="lastname" class="form-control" id="inputLastname" placeholder="Last Name"
                        value="<?php echo Form::value("lastname"); ?>">
                      <small class="form-text text-muted kt-font-danger"><?php echo Form::error("lastname"); ?></small>
                    </div>
                    
                    <div class="form-group <?php if (Form::error("pass")) {echo 'has-error';}?>">
                      <label for="inputPassword">New Password:</label>
                      <input type="password" name="pass" class="form-control" id="inputPassword" placeholder="New Password">
                      <small class="form-text text-muted kt-font-danger"><?php echo Form::error("pass"); ?></small>
                    </div>

                    <div class="form-group <?php if (Form::error("conf_newpass")) {echo 'has-error';}?>">
                      <label for="confirmPassword">Confirm Password:</label>
                      <input type="password" name="conf_pass" class="form-control" id="confirmPassword"
                        placeholder="Confirm Password">
                      <small class="form-text text-muted kt-font-danger"><?php echo Form::error("pass"); ?></small>
                    </div>

                    <div class="form-group <?php if (Form::error("email")) {echo 'has-error';}?>">
                      <label for="email">E-mail:</label>
                      <input type="text" id="email" name="email" class="form-control" placeholder="Email"
                        value="<?php echo Form::value("email"); ?>">
                      <small class="form-text text-muted kt-font-danger"><?php echo Form::error("email"); ?></small>
                    </div>

                    <input type="hidden" name="form_submission" value="admin_registration">
                  </div>
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                  <button type="submit" class="btn btn-primary" id="add_new_user">Create New User</button>
                </div>
              </form>
            </div>
          </div>
        </div>
        <!-- END Modal -->


      </div>
    </div>
  </div>
  <!----------------------------------- ./End Page Content -------------------------------------->

</div>
<!-- END Page Wrapper -->

<?php include $tpl . 'footer.php';?>

<?php if (Form::error("user") || Form::error("firstname") || Form::error("lastname") || Form::error("pass") || Form::error("conf_newpass") || Form::error("email")) {?>
  <script>
    $(document).ready(function () {
      $('#createUser').modal('show');
    });
  </script>
<?php } ?>
</body>

</html>
<?php
}
?>